This document describes overlays provided in the kernel packages
For generic Armbian overlays documentation please see
https://docs.armbian.com/User-Guide_Allwinner_overlays/

### Platform:

sun8i-h3 (Allwinner H3)

### Platform details:

Supported pin banks: PA, PC, PD, PG

Both SPI controllers have only one hardware CS pin exposed,
adding fixed software (GPIO) chip selects is possible with a separate overlay

### Provided overlays:

- analog-codec
- cir
- i2c0
- i2c1
- i2c2
- pps-gpio
- pwm
- spdif-out
- spi-add-cs1
- spi-jedec-nor
- spi-spidev
- uart1
- uart2
- uart3
- usbhost0
- usbhost1
- usbhost2
- usbhost3
- w1-gpio

### Overlay details:

### analog-codec

Activates SoC analog codec driver that provides Line Out and Mic In
functionality

### cir

Activates CIR (Infrared remote) receiver

CIR pin: PL11

### i2c0

Activates TWI/I2C bus 0

I2C0 pins (SCL, SDA): PA11, PA12

### i2c1

Activates TWI/I2C bus 1

I2C1 pins (SCL, SDA): PA18, PA19

### i2c2

Activates TWI/I2C bus 2

I2C2 pins (SCL, SDA): PE12, PE13

On most board this bus is wired to Camera (CSI) socket

### pps-gpio

Activates pulse-per-second GPIO client

Parameters:

param_pps_pin (pin)
	Pin PPS source is connected to
	Optional
	Default: PD14

param_pps_falling_edge (bool)
	Assert by falling edge
	Optional
	Default: 0
	When set (to 1), assert is indicated by a falling edge
		(instead of by a rising edge)

### pwm

Activates hardware PWM controller

PWM pin: PA5

Pin PA5 is used as UART0 RX by default, so if this overlay is activated,
UART0 and kernel console on ttyS0 will be disabled

### spdif-out

Activates SPDIF/Toslink audio output

SPDIF pin: PA17

### spi-add-cs1

Adds support for using SPI chip select 1 with GPIO for both SPI controllers
Respective GPIO will be claimed only if controller is enabled by another
overlay
This overlay is required for using chip select 1 with other SPI overlays
Due to the u-boot limitations CS1 pin can't be customized by a parameter, but
it can be changed by using an edited copy of this overlay
A total of 4 chip selects can be used with custom overlays (1 HW + 3 GPIO)

SPI 0 pins (CS1): PA21
SPI 1 pins (CS1): PA10

### spi-jedec-nor

Activates MTD support for JEDEC compatible SPI NOR flash chips on SPI bus
supported by the kernel SPI NOR driver

SPI 0 pins (MOSI, MISO, SCK, CS): PC0, PC1, PC2, PC3
SPI 1 pins (MOSI, MISO, SCK, CS): PA15, PA16, PA14, PA13

Parameters:

param_spinor_spi_bus (int)
	SPI bus to activate SPI NOR flash support on
	Required
	Supported values: 0, 1

param_spinor_spi_cs (int)
	SPI chip select number
	Optional
	Default: 0
	Supported values: 0, 1
	Using chip select 1 requires using "spi-add-cs1" overlay

param_spinor_max_freq (int)
	Maximum SPI frequency
	Optional
	Default: 1000000
	Range: 3000 - 100000000

### spi-spidev

Activates SPIdev device node (/dev/spidevX.Y) for userspace SPI access,
where X is the bus number and Y is the CS number

SPI 0 pins (MOSI, MISO, SCK, CS): PC0, PC1, PC2, PC3
SPI 1 pins (MOSI, MISO, SCK, CS): PA15, PA16, PA14, PA13

Parameters:

param_spidev_spi_bus (int)
	SPI bus to activate SPIdev support on
	Required
	Supported values: 0, 1

param_spidev_spi_cs (int)
	SPI chip select number
	Optional
	Default: 0
	Supported values: 0, 1
	Using chip select 1 requires using "spi-add-cs1" overlay

param_spidev_max_freq (int)
	Maximum SPIdev frequency
	Optional
	Default: 1000000
	Range: 3000 - 100000000

### uart1

Activates serial port 1 (/dev/ttyS1)

UART 1 pins (TX, RX, RTS, CTS): PG6, PG7, PG8, PG9

Parameters:

param_uart1_rtscts (bool)
	Enable RTS and CTS pins
	Optional
	Default: 0
	Set to 1 to enable

### uart2

Activates serial port 2 (/dev/ttyS2)

UART 2 pins (TX, RX, RTS, CTS): PA0, PA1, PA2, PA3

Parameters:

param_uart2_rtscts (bool)
	Enable RTS and CTS pins
	Optional
	Default: 0
	Set to 1 to enable CTS and RTS pins

### uart3

Activates serial port 3 (/dev/ttyS3)

UART 3 pins (TX, RX, RTS, CTS): PA13, PA14, PA15, PA16

Parameters:

param_uart3_rtscts (bool)
	Enable RTS and CTS pins
	Optional
	Default: 0
	Set to 1 to enable CTS and RTS pins

### usbhost0

Activates USB host controller 0

### usbhost1

Activates USB host controller 1

### usbhost2

Activates USB host controller 2

### usbhost3

Activates USB host controller 3

### w1-gpio

Activates 1-Wire GPIO master
Requires an external pull-up resistor on the data pin
or enabling the internal pull-up

Parameters:

param_w1_pin (pin)
	Data pin for 1-Wire master
	Optional
	Default: PD14

param_w1_pin_int_pullup (bool)
	Enable internal pull-up for the data pin
	Optional
	Default: 0
	Set to 1 to enable the pull-up
	This option should not be used with multiple devices, parasite power setup
		or long wires -	please use external pull-up resistor instead
